part of spark;

/// theme widget builder
typedef WidgetThemeBuilder = Widget Function(BuildContext context, SparkTheme theme);

enum Direction {
  /// horizontal direction
  horizontal,

  /// vertical direction
  vertical,
}

enum FormStrategy {
  /// form change strategy, if valitate error, back to old value
  limit,

  /// just tip error message
  tip
}

/// valitate function
typedef ValidateCallback = ValidateResult Function(dynamic value, VerifyType type);

/// updater
typedef ValueUpdater = void Function(String value);

/// custom form widget builder
/// [value] is form item field value, that call on [value] change
/// [updater] value's updater, receive new [value] and update widget builder
typedef FormItemWrapperBuilder = Widget Function(BuildContext context, String value, ValueUpdater updater);

/// spark select item options builder
/// [SparkSelect]
typedef ItemValueBuilder = Widget Function(BuildContext context, SparkOption value);

/// check string is empty
bool emptyOrNullString(String? value){
  return value == null || value == '';
}