part of spark_widget;

class SparkWrapper extends SparkFormWidget {
  const SparkWrapper({
    Key? key,
    required this.builder,
    required FormItemManage manage,
  }) : super(key: key, manage: manage);

  final FormItemWrapperBuilder builder;

  @override
  State<StatefulWidget> createState() => _SparkWrapperBase();
}

class _SparkWrapperBase extends SparkFormWidgetBase<SparkWrapper> {
  /// listener controller change
  /// update widget
  void _changeListener() {
    if (!mounted) {
      return;
    }
    setState(() {});
  }

  void _handleValueChange(String value) {
    handleFormDataChange(value, oldValue);
    oldValue = widget.manage.controller.text;
  }

  @override
  void initState() {
    oldValue = '';
    // 监听控制器变化，进行子节点刷新
    widget.manage.controller.addListener(_changeListener);
    super.initState();
  }

  @override
  void dispose() {
    widget.manage.controller.removeListener(_changeListener);
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    String _value = widget.manage.controller.text;
    return widget.builder(context, _value, _handleValueChange);
  }
}
